Index: issm/trunk/examples/IceBridge/Greenland.par
===================================================================
--- issm/trunk/examples/IceBridge/Greenland.par	(revision 18301)
+++ issm/trunk/examples/IceBridge/Greenland.par	(revision 18301)
@@ -0,0 +1,104 @@
+%Name and hemisphere
+md.miscellaneous.name='SeaRISEgreenland';
+md.mesh.hemisphere='n';
+
+disp('   Loading SeaRISE data from NetCDF');
+ncdata='../Data/Greenland_5km_dev1.2.nc';
+x1    = ncread(ncdata,'x1');
+y1    = ncread(ncdata,'y1');
+usrf  = ncread(ncdata,'usrf')';
+topg  = ncread(ncdata,'topg')';
+velx  = ncread(ncdata,'surfvelx')';
+vely  = ncread(ncdata,'surfvely')';
+temp  = ncread(ncdata,'airtemp2m')';
+smb   = ncread(ncdata,'smb')';
+gflux = ncread(ncdata,'bheatflx')';
+
+disp('   Interpolating surface and bedrock');
+md.geometry.base     = InterpFromGridToMesh(x1,y1,topg,md.mesh.x,md.mesh.y,0);
+md.geometry.surface = InterpFromGridToMesh(x1,y1,usrf,md.mesh.x,md.mesh.y,0);
+
+disp('   Constructing thickness');
+md.geometry.thickness=md.geometry.surface-md.geometry.base;
+
+%Set min thickness to 1 meter
+pos0=find(md.geometry.thickness<=0);
+md.geometry.thickness(pos0)=1;
+md.geometry.surface=md.geometry.thickness+md.geometry.base;
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%Reading IceBridge data for Jakobshavn
+disp('      reading IceBridge Jakobshavn bedrock');
+fid  = fopen('../Data/Jakobshavn_2008_2011_Composite_XYZGrid.txt');
+titles = fgets(fid); data = fscanf(fid,'%g,%g,%g,%g,%g',[5 266400])';
+fclose(fid);
+
+[xi,yi]= ll2xy(md.mesh.lat,md.mesh.long,+1,45,70);
+bed  = flipud(reshape(data(:,5),[360 740])); bed(find(bed==-9999))=NaN;
+bedy = flipud(reshape(data(:,1),[360 740]));
+bedx = flipud(reshape(data(:,2),[360 740]));
+
+%Insert Icebridge bed and recalculate thickness
+bed_jks=InterpFromGridToMesh(bedx(1,:)',bedy(:,1),bed,xi,yi,NaN);
+in=ContourToMesh(md.mesh.elements,md.mesh.x,md.mesh.y,...
+	'./Jak_grounded.exp','node',1);
+bed_jks(~in)=NaN;
+pos=find(~isnan(bed_jks));
+md.geometry.base(pos)=bed_jks(pos);
+md.geometry.thickness=md.geometry.surface-md.geometry.base;
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+
+disp('   Interpolating velocities ');
+md.inversion.vx_obs  = InterpFromGridToMesh(x1,y1,velx,md.mesh.x,md.mesh.y,0);
+md.inversion.vy_obs  = InterpFromGridToMesh(x1,y1,vely,md.mesh.x,md.mesh.y,0);
+md.inversion.vel_obs = sqrt(md.inversion.vx_obs.^2+md.inversion.vy_obs.^2);
+md.initialization.vx = md.inversion.vx_obs;
+md.initialization.vy = md.inversion.vy_obs;
+md.initialization.vz = zeros(md.mesh.numberofvertices,1);
+md.initialization.vel= md.inversion.vel_obs;
+
+disp('   Interpolating temperatures');
+md.initialization.temperature=InterpFromGridToMesh(x1,y1,temp,md.mesh.x,md.mesh.y,0)+273.15;
+
+disp('   Interpolating surface mass balance');
+md.surfaceforcings.mass_balance=InterpFromGridToMesh(x1,y1,smb,md.mesh.x,md.mesh.y,0);
+md.surfaceforcings.mass_balance=md.surfaceforcings.mass_balance*md.materials.rho_water/md.materials.rho_ice;
+
+disp('   Construct basal friction parameters');
+md.friction.coefficient=30*ones(md.mesh.numberofvertices,1);
+pos=find(md.mask.groundedice_levelset<0);
+md.friction.coefficient(pos)=0; %no friction applied on floating ice
+md.friction.p=ones(md.mesh.numberofelements,1);
+md.friction.q=ones(md.mesh.numberofelements,1);
+
+disp('   Construct ice rheological properties');
+md.materials.rheology_n=3*ones(md.mesh.numberofelements,1);
+md.materials.rheology_B=paterson(md.initialization.temperature);
+md.friction.q=ones(md.mesh.numberofelements,1);
+md.friction.p=ones(md.mesh.numberofelements,1);
+
+disp('   Set other boundary conditions');
+md.mask.ice_levelset(md.mesh.vertexonboundary==1)=0;
+md.basalforcings.groundedice_melting_rate = zeros(md.mesh.numberofvertices,1);
+md.basalforcings.floatingice_melting_rate = zeros(md.mesh.numberofvertices,1);
+md.thermal.spctemperature     = [md.initialization.temperature;1]; %impose observed temperature on surface
+md.masstransport.spcthickness    = NaN*ones(md.mesh.numberofvertices,1);
+
+disp('   Set geothermal heat flux');
+md.basalforcings.geothermalflux=InterpFromGridToMesh(x1,y1,gflux,md.mesh.x,md.mesh.y,0);
+
+disp('   Set Pressure');
+md.initialization.pressure=md.materials.rho_ice*md.constants.g*md.geometry.thickness;
+
+disp('   Single point constraint for continental model');
+%Set at least one vertex to velocity 0 so as to not get a singular problem (point on the wet peninsula)
+md.stressbalance.referential=NaN*ones(md.mesh.numberofvertices,6);
+md.stressbalance.spcvx = NaN*ones(md.mesh.numberofvertices,1);
+md.stressbalance.spcvy = NaN*ones(md.mesh.numberofvertices,1);
+md.stressbalance.spcvz = NaN*ones(md.mesh.numberofvertices,1);
+location = 1.0e+06 *[.32011 -2.2039];
+[dist pos]=min(sqrt((md.mesh.x - location(1)).^2 + (md.mesh.y - location(2)).^2));
+md.stressbalance.spcvx(pos) = 0;
+md.stressbalance.spcvy(pos) = 0;
+md.stressbalance.spcvz(pos) = 0;
+
Index: issm/trunk/examples/IceBridge/Greenland_cheatsheet.par
===================================================================
--- issm/trunk/examples/IceBridge/Greenland_cheatsheet.par	(revision 18301)
+++ issm/trunk/examples/IceBridge/Greenland_cheatsheet.par	(revision 18301)
@@ -0,0 +1,108 @@
+%Name and hemisphere
+md.miscellaneous.name='SeaRISEgreenland';
+md.mesh.hemisphere='n';
+
+disp('   Loading SeaRISE data from NetCDF');
+ncdata='../Data/Greenland_5km_dev1.2.nc';
+x1    = ncread(ncdata,'x1');
+y1    = ncread(ncdata,'y1');
+usrf  = ncread(ncdata,'usrf')';
+topg  = ncread(ncdata,'topg')';
+velx  = ncread(ncdata,'surfvelx')';
+vely  = ncread(ncdata,'surfvely')';
+temp  = ncread(ncdata,'airtemp2m')';
+smb   = ncread(ncdata,'smb')';
+gflux = ncread(ncdata,'bheatflx')';
+
+disp('   Interpolating surface and bedrock');
+md.geometry.base     = InterpFromGridToMesh(x1,y1,topg,md.mesh.x,md.mesh.y,0);
+md.geometry.surface = InterpFromGridToMesh(x1,y1,usrf,md.mesh.x,md.mesh.y,0);
+
+disp('   Constructing thickness');
+md.geometry.thickness=md.geometry.surface-md.geometry.base;
+
+%Set min thickness to 1 meter
+pos0=find(md.geometry.thickness<=0);
+md.geometry.thickness(pos0)=1;
+md.geometry.surface=md.geometry.thickness+md.geometry.base;
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%Reading IceBridge data for Jakobshavn
+disp('      reading IceBridge Jakobshavn bedrock');
+fid  = fopen('../Data/Jakobshavn_2008_2011_Composite_XYZGrid.txt');
+titles = fgets(fid); data = fscanf(fid,'%g,%g,%g,%g,%g',[5 266400])';
+fclose(fid);
+
+[xi,yi]= ll2xy(md.mesh.lat,md.mesh.long,+1,45,70);
+bed  = flipud(reshape(data(:,5),[360 740])); bed(find(bed==-9999))=NaN;
+surf  = flipud(reshape(data(:,4),[360 740])); surf(find(surf==-9999))=NaN;
+bedy = flipud(reshape(data(:,1),[360 740]));
+bedx = flipud(reshape(data(:,2),[360 740]));
+
+%Insert Icebridge bed and recalculate thickness
+bed_jks=InterpFromGridToMesh(bedx(1,:)',bedy(:,1),bed,xi,yi,NaN);
+surf_jks=InterpFromGridToMesh(bedx(1,:)',bedy(:,1),surf,xi,yi,NaN);
+in=ContourToMesh(md.mesh.elements,md.mesh.x,md.mesh.y,...
+	'./Jak_grounded.exp','node',1);
+bed_jks(~in)=NaN;
+surf_jks(~in)=NaN;
+pos=find(~isnan(bed_jks));
+md.geometry.base(pos)=bed_jks(pos);
+md.geometry.surface(pos)=surf_jks(pos);
+md.geometry.thickness=md.geometry.surface-md.geometry.base;
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+
+disp('   Interpolating velocities ');
+md.inversion.vx_obs  = InterpFromGridToMesh(x1,y1,velx,md.mesh.x,md.mesh.y,0);
+md.inversion.vy_obs  = InterpFromGridToMesh(x1,y1,vely,md.mesh.x,md.mesh.y,0);
+md.inversion.vel_obs = sqrt(md.inversion.vx_obs.^2+md.inversion.vy_obs.^2);
+md.initialization.vx = md.inversion.vx_obs;
+md.initialization.vy = md.inversion.vy_obs;
+md.initialization.vz = zeros(md.mesh.numberofvertices,1);
+md.initialization.vel= md.inversion.vel_obs;
+
+disp('   Interpolating temperatures');
+md.initialization.temperature=InterpFromGridToMesh(x1,y1,temp,md.mesh.x,md.mesh.y,0)+273.15;
+
+disp('   Interpolating surface mass balance');
+md.surfaceforcings.mass_balance=InterpFromGridToMesh(x1,y1,smb,md.mesh.x,md.mesh.y,0);
+md.surfaceforcings.mass_balance=md.surfaceforcings.mass_balance*md.materials.rho_water/md.materials.rho_ice;
+
+disp('   Construct basal friction parameters');
+md.friction.coefficient=30*ones(md.mesh.numberofvertices,1);
+pos=find(md.mask.groundedice_levelset<0);
+md.friction.coefficient(pos)=0; %no friction applied on floating ice
+md.friction.p=ones(md.mesh.numberofelements,1);
+md.friction.q=ones(md.mesh.numberofelements,1);
+
+disp('   Construct ice rheological properties');
+md.materials.rheology_n=3*ones(md.mesh.numberofelements,1);
+md.materials.rheology_B=paterson(md.initialization.temperature);
+md.friction.q=ones(md.mesh.numberofelements,1);
+md.friction.p=ones(md.mesh.numberofelements,1);
+
+disp('   Set other boundary conditions');
+md.mask.ice_levelset(md.mesh.vertexonboundary==1)=0;
+md.basalforcings.groundedice_melting_rate = zeros(md.mesh.numberofvertices,1);
+md.basalforcings.floatingice_melting_rate = zeros(md.mesh.numberofvertices,1);
+md.thermal.spctemperature     = [md.initialization.temperature;1]; %impose observed temperature on surface
+md.masstransport.spcthickness    = NaN*ones(md.mesh.numberofvertices,1);
+
+disp('   Set geothermal heat flux');
+md.basalforcings.geothermalflux=InterpFromGridToMesh(x1,y1,gflux,md.mesh.x,md.mesh.y,0);
+
+disp('   Set Pressure');
+md.initialization.pressure=md.materials.rho_ice*md.constants.g*md.geometry.thickness;
+
+disp('   Single point constraint for continental model');
+%Set at least one vertex to velocity 0 so as to not get a singular problem (point on the wet peninsula)
+md.stressbalance.referential=NaN*ones(md.mesh.numberofvertices,6);
+md.stressbalance.spcvx = NaN*ones(md.mesh.numberofvertices,1);
+md.stressbalance.spcvy = NaN*ones(md.mesh.numberofvertices,1);
+md.stressbalance.spcvz = NaN*ones(md.mesh.numberofvertices,1);
+location = 1.0e+06 *[.32011 -2.2039];
+[dist pos]=min(sqrt((md.mesh.x - location(1)).^2 + (md.mesh.y - location(2)).^2));
+md.stressbalance.spcvx(pos) = 0;
+md.stressbalance.spcvy(pos) = 0;
+md.stressbalance.spcvz(pos) = 0;
+
Index: issm/trunk/examples/IceBridge/Greenland_noOIB.par
===================================================================
--- issm/trunk/examples/IceBridge/Greenland_noOIB.par	(revision 18301)
+++ issm/trunk/examples/IceBridge/Greenland_noOIB.par	(revision 18301)
@@ -0,0 +1,82 @@
+%Name and hemisphere
+md.miscellaneous.name='SeaRISEgreenland';
+md.mesh.hemisphere='n';
+
+disp('   Loading SeaRISE data from NetCDF');
+ncdata='../Data/Greenland_5km_dev1.2.nc';
+x1    = ncread(ncdata,'x1');
+y1    = ncread(ncdata,'y1');
+usrf  = ncread(ncdata,'usrf')';
+topg  = ncread(ncdata,'topg')';
+velx  = ncread(ncdata,'surfvelx')';
+vely  = ncread(ncdata,'surfvely')';
+temp  = ncread(ncdata,'airtemp2m')';
+smb   = ncread(ncdata,'smb')';
+gflux = ncread(ncdata,'bheatflx')';
+
+disp('   Interpolating surface and bedrock');
+md.geometry.base     = InterpFromGridToMesh(x1,y1,topg,md.mesh.x,md.mesh.y,0);
+md.geometry.surface = InterpFromGridToMesh(x1,y1,usrf,md.mesh.x,md.mesh.y,0);
+
+disp('   Constructing thickness');
+md.geometry.thickness=md.geometry.surface-md.geometry.base;
+
+%Set min thickness to 1 meter
+pos0=find(md.geometry.thickness<=0);
+md.geometry.thickness(pos0)=1;
+md.geometry.surface=md.geometry.thickness+md.geometry.base;
+
+disp('   Interpolating velocities ');
+md.inversion.vx_obs  = InterpFromGridToMesh(x1,y1,velx,md.mesh.x,md.mesh.y,0);
+md.inversion.vy_obs  = InterpFromGridToMesh(x1,y1,vely,md.mesh.x,md.mesh.y,0);
+md.inversion.vel_obs = sqrt(md.inversion.vx_obs.^2+md.inversion.vy_obs.^2);
+md.initialization.vx = md.inversion.vx_obs;
+md.initialization.vy = md.inversion.vy_obs;
+md.initialization.vz = zeros(md.mesh.numberofvertices,1);
+md.initialization.vel= md.inversion.vel_obs;
+
+disp('   Interpolating temperatures');
+md.initialization.temperature=InterpFromGridToMesh(x1,y1,temp,md.mesh.x,md.mesh.y,0)+273.15;
+
+disp('   Interpolating surface mass balance');
+md.surfaceforcings.mass_balance=InterpFromGridToMesh(x1,y1,smb,md.mesh.x,md.mesh.y,0);
+md.surfaceforcings.mass_balance=md.surfaceforcings.mass_balance*md.materials.rho_water/md.materials.rho_ice;
+
+disp('   Construct basal friction parameters');
+md.friction.coefficient=30*ones(md.mesh.numberofvertices,1);
+pos=find(md.mask.groundedice_levelset<0);
+md.friction.coefficient(pos)=0; %no friction applied on floating ice
+md.friction.p=ones(md.mesh.numberofelements,1);
+md.friction.q=ones(md.mesh.numberofelements,1);
+
+disp('   Construct ice rheological properties');
+md.materials.rheology_n=3*ones(md.mesh.numberofelements,1);
+md.materials.rheology_B=paterson(md.initialization.temperature);
+md.friction.q=ones(md.mesh.numberofelements,1);
+md.friction.p=ones(md.mesh.numberofelements,1);
+
+disp('   Set other boundary conditions');
+md.mask.ice_levelset(md.mesh.vertexonboundary==1)=0;
+md.basalforcings.groundedice_melting_rate = zeros(md.mesh.numberofvertices,1);
+md.basalforcings.floatingice_melting_rate = zeros(md.mesh.numberofvertices,1);
+md.thermal.spctemperature     = [md.initialization.temperature;1]; %impose observed temperature on surface
+md.masstransport.spcthickness    = NaN*ones(md.mesh.numberofvertices,1);
+
+disp('   Set geothermal heat flux');
+md.basalforcings.geothermalflux=InterpFromGridToMesh(x1,y1,gflux,md.mesh.x,md.mesh.y,0);
+
+disp('   Set Pressure');
+md.initialization.pressure=md.materials.rho_ice*md.constants.g*md.geometry.thickness;
+
+disp('   Single point constraint for continental model');
+%Set at least one vertex to velocity 0 so as to not get a singular problem (point on the wet peninsula)
+md.stressbalance.referential=NaN*ones(md.mesh.numberofvertices,6);
+md.stressbalance.spcvx = NaN*ones(md.mesh.numberofvertices,1);
+md.stressbalance.spcvy = NaN*ones(md.mesh.numberofvertices,1);
+md.stressbalance.spcvz = NaN*ones(md.mesh.numberofvertices,1);
+location = 1.0e+06 *[.32011 -2.2039];
+[dist pos]=min(sqrt((md.mesh.x - location(1)).^2 + (md.mesh.y - location(2)).^2));
+md.stressbalance.spcvx(pos) = 0;
+md.stressbalance.spcvy(pos) = 0;
+md.stressbalance.spcvz(pos) = 0;
+
Index: issm/trunk/examples/IceBridge/Jak_grounded.exp
===================================================================
--- issm/trunk/examples/IceBridge/Jak_grounded.exp	(revision 18301)
+++ issm/trunk/examples/IceBridge/Jak_grounded.exp	(revision 18301)
@@ -0,0 +1,19 @@
+## Name:Jak_grouded
+## Icon:0
+# Points Count Value
+13 1.000000
+# X pos Y pos
+-414397.6663804040 -2243466.6708395295
+-421486.9037621063 -2215731.3059818177
+-342860.8164377716 -2178965.8223332223
+-275835.2993744044 -2209281.2211311869
+-226210.6377024883 -2262816.9253914217
+-228144.0660793162 -2295067.3496445753
+-333193.6745536321 -2328607.7908678548
+-379595.9555975018 -2325382.7484425395
+-422775.8560133249 -2285392.2223686292
+-427287.1888925899 -2265396.9593316740
+-411819.7618779668 -2254431.8150856020
+-413108.7141291854 -2243466.6708395295
+-414397.6663804040 -2243466.6708395295
+
Index: issm/trunk/examples/IceBridge/Jak_outline.exp
===================================================================
--- issm/trunk/examples/IceBridge/Jak_outline.exp	(revision 18301)
+++ issm/trunk/examples/IceBridge/Jak_outline.exp	(revision 18301)
@@ -0,0 +1,17 @@
+## Name:Jak
+## Icon:0
+# Points Count Value
+11 1.000000
+# X pos Y pos
+-421561.7247949215 -2216716.3488182197
+-386019.6416099078 -2203459.4896082953
+-351446.8879663036 -2185999.2360147359
+-289086.6874689616 -2214129.6445821370
+-255160.1535196303 -2282353.9688088228
+-340138.0433165266 -2317597.8140254519
+-383306.1449952667 -2302506.6581698526
+-416391.9672407377 -2279120.5885137189
+-448056.7322601135 -2246463.4475331730
+-429126.8716234095 -2231167.6696134652
+-421561.7247949215 -2216716.3488182197
+
Index: issm/trunk/examples/IceBridge/data_gaps.exp
===================================================================
--- issm/trunk/examples/IceBridge/data_gaps.exp	(revision 18301)
+++ issm/trunk/examples/IceBridge/data_gaps.exp	(revision 18301)
@@ -0,0 +1,70 @@
+## Name:data_gaps
+## Icon:0
+# Points Count Value
+13 1.000000
+# X pos Y pos
+-183076.0390091268 -1794119.5324780210
+-233886.6983670916 -1838953.5447257366
+-239864.4229974404 -2006333.8571172084
+-299641.6693009282 -2081057.2108634012
+-269753.0461491842 -2116924.4206615738
+-257797.5968884868 -2185669.9061080711
+-278719.6330947075 -2248437.5232548732
+-254808.7345733123 -2266371.1281539593
+-224920.1114215683 -2167736.3012089850
+-198020.3505849990 -2093012.9474627920
+-123298.7927056390 -1967477.7131691882
+-180087.1766939524 -1797108.4666278686
+-183076.0390091268 -1794119.5324780210
+
+## Name:data_gaps
+## Icon:0
+# Points Count Value
+12 1.000000
+# X pos Y pos
+-90421.3072387208 -1824008.8739764981
+-117321.0680752902 -1946555.1741202541
+-156176.2781725575 -2075079.3425637058
+-177098.3143787782 -2203603.5110071572
+-174109.4520636038 -2314194.0745515227
+-72488.1333476745 -2293271.5355025884
+-93410.1695538952 -2203603.5110071572
+-30644.0609352330 -2206592.4451570050
+-6733.1624138379 -2081057.2108634012
+44077.4969441269 -1967477.7131691882
+-93410.1695538952 -1824008.8739764981
+-90421.3072387208 -1824008.8739764981
+
+## Name:data_gaps
+## Icon:0
+# Points Count Value
+15 1.000000
+# X pos Y pos
+-87432.4449235464 -2365005.9550989335
+-287686.2200402305 -2639987.8968849229
+-284697.3577250564 -2879102.6288727401
+-470006.8212658686 -2983715.3241174100
+-538750.6545148797 -3157073.5048085772
+-356430.0532892416 -3267664.0683529424
+-189053.7636394757 -3270653.0025027902
+-272741.9084643587 -3243752.5951541606
+-218942.3867912197 -3076372.2827626891
+-236875.5606822660 -3019582.5339155826
+-117321.0680752902 -2834268.6166250245
+20166.5984227317 -2669877.2383834003
+-12710.8870441865 -2469618.6503436035
+-87432.4449235464 -2367994.8892487814
+-87432.4449235464 -2365005.9550989335
+
+## Name:data_gaps
+## Icon:0
+# Points Count Value
+6 1.000000
+# X pos Y pos
+-186064.9013243013 -1555004.8004902040
+-177098.3143787782 -1695484.7055330465
+-81454.7202931975 -1698473.6396828941
+-36621.7855655816 -1513159.7223923360
+-186064.9013243013 -1552015.8663403564
+-186064.9013243013 -1555004.8004902040
+
Index: issm/trunk/examples/IceBridge/runme.m
===================================================================
--- issm/trunk/examples/IceBridge/runme.m	(revision 18301)
+++ issm/trunk/examples/IceBridge/runme.m	(revision 18301)
@@ -0,0 +1,159 @@
+clear all;
+steps=[1];
+
+%Location of SeaRISE dataset
+ncdata='../Data/Greenland_5km_dev1.2.nc';
+
+if any(steps==1)
+	disp('   Step 1: Mesh creation');
+
+	%Generate initial uniform mesh (resolution = 20000 m)
+	md=triangle(model,'./DomainOutline.exp',20000);
+
+	% Get velocities (Note: You can use ncdisp('file') to see an ncdump)
+	x1   = ncread(ncdata,'x1');
+	y1   = ncread(ncdata,'y1');
+	velx = ncread(ncdata,'surfvelx');
+	vely = ncread(ncdata,'surfvely');
+	vx   = InterpFromGridToMesh(x1,y1,velx',md.mesh.x,md.mesh.y,0);
+	vy   = InterpFromGridToMesh(x1,y1,vely',md.mesh.x,md.mesh.y,0);
+	vel  = sqrt(vx.^2+vy.^2);
+
+	%Mesh greenland without refinement in Jak basin
+	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+	md=bamg(md,'hmax',400000,'hmin',5000,'gradation',1.7,'field',vel,'err',8);
+	save ./Models/Greenland.Mesh_generation_old md;
+	return;
+	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+
+	%Refine mesh in the region of Jakobshavn (resolution = 3000 m)
+	hmaxVertices=NaN*ones(md.mesh.numberofvertices,1);
+	in=ContourToMesh(md.mesh.elements,md.mesh.x,md.mesh.y,...
+		'./Jak_outline.exp','node',1);
+	hmaxVertices(find(in))=3000;
+	md=bamg(md,'hmax',400000,'hmin',5000,'gradation',1.7,'field',vel,...
+		'err',8,'hmaxVertices',hmaxVertices);
+
+	%convert x,y coordinates (Polar stereo) to lat/lon
+	[md.mesh.lat,md.mesh.long]=xy2ll(md.mesh.x,md.mesh.y,+1,39,71);
+
+	save ./Models/Greenland.Mesh_generation md;
+end
+
+if any(steps==2)
+	disp('   Step 2: Parameterization');
+	md = loadmodel('./Models/Greenland.Mesh_generation');
+
+	md = setmask(md,'','');
+	md = parameterize(md,'./Greenland_cheatsheet.par');
+	%md = parameterize(md,'./Greenland_noOIB.par');
+	md = setflowequation(md,'SSA','all');
+
+	save ./Models/Greenland.Parameterization2 md; 
+end
+
+if any(steps==3)
+	disp('   Step 3: Control method friction');
+	md = loadmodel('./Models/Greenland.Parameterization2');
+
+	%Control general
+	md.inversion.iscontrol=1;
+	md.inversion.nsteps=30;
+	md.inversion.step_threshold=0.99*ones(md.inversion.nsteps,1);
+	md.inversion.maxiter_per_step=5*ones(md.inversion.nsteps,1);
+	md.verbose=verbose('solution',true,'control',true);
+
+	%Cost functions
+	md.inversion.cost_functions=[101 103 501];
+	md.inversion.cost_functions_coefficients=ones(md.mesh.numberofvertices,3);
+	md.inversion.cost_functions_coefficients(:,1)=350;
+	md.inversion.cost_functions_coefficients(:,2)=0.6;
+	md.inversion.cost_functions_coefficients(:,3)=2e-6;
+
+	%Controls
+	md.inversion.control_parameters={'FrictionCoefficient'};
+	md.inversion.gradient_scaling(1:md.inversion.nsteps)=50;
+	md.inversion.min_parameters=1*ones(md.mesh.numberofvertices,1);
+	md.inversion.max_parameters=200*ones(md.mesh.numberofvertices,1);
+	in=ContourToMesh(md.mesh.elements,md.mesh.x,md.mesh.y,...
+		'./data_gaps.exp','node',1);
+	md.inversion.cost_functions_coefficients(find(in),1)=0.0;
+	md.inversion.cost_functions_coefficients(find(in),2)=0.0;
+
+	%Additional parameters
+	md.stressbalance.restol=0.01;
+	md.stressbalance.reltol=0.1;
+	md.stressbalance.abstol=NaN;
+
+	%Go solve
+	md.cluster=generic('name',oshostname,'np',2);
+
+	md.verbose=verbose('solution',true,'control',true);
+	md=solve(md,StressbalanceSolutionEnum);
+
+	%Update model friction fields accordingly
+	md.friction.coefficient=md.results.StressbalanceSolution.FrictionCoefficient;
+
+	save ./Models/Greenland.Control_drag md; 
+end
+
+if any(steps==4)
+	disp('   Step 4: Transient run');
+	md = loadmodel('./Models/Greenland.Control_drag');
+
+	%Set surface mass balance
+	x1  = ncread(ncdata,'x1');
+	y1  = ncread(ncdata,'y1');
+	smb = ncread(ncdata,'smb');
+	smb = InterpFromGridToMesh(x1,y1,smb',md.mesh.x,md.mesh.y,0)*1000/md.materials.rho_ice;
+	smb = [smb smb smb-1.0];
+	md.surfaceforcings.mass_balance = [smb;1 10 20];
+
+	%Set transient options, run for 20 years, saving every year
+	md.timestepping.time_step=0.2; %This must be reduced for finer resolutions
+	md.timestepping.final_time=20;
+	md.settings.output_frequency=1;
+
+	%Additional options
+	md.inversion.iscontrol=0;
+	md.transient.requested_outputs={'IceVolume','TotalSmb','SurfaceforcingsMassBalance'};
+	md.verbose=verbose('solution',true,'module',true,'convergence',true);
+
+	%Go solve
+	md.cluster=generic('name',oshostname,'np',2);
+	md=solve(md,TransientSolutionEnum);
+
+	save ./Models/Greenland.Transient md; 
+end
+
+if any(steps==5)
+	disp('   Step 5: Plotting'); 
+	md = loadmodel('./Models/Greenland.Transient');
+
+	%Planview plots
+	plotmodel(md,'data',md.results.TransientSolution(end).Vel,'caxis',[1e-1 6000],...
+		'log', 10, 'title', 'Velocity (m/y)','gridded',1, ...
+		'data', md.results.TransientSolution(end).SurfaceforcingsMassBalance, ...
+		'title', 'Surface mass balance (m/y)','gridded',1, ...
+		'data',md.results.TransientSolution(end).Thickness,...
+		'title','Thickness (m)','gridded',1, ...
+		'data',md.results.TransientSolution(end).Surface, ...
+		'title', 'Surface (m)','gridded',1);
+
+	%Line Plots
+	figure
+
+	%Plot surface mass balance
+	surfmb=[]; for i=1:100; surfmb=[surfmb ...
+		md.results.TransientSolution(i).SurfaceforcingsMassBalance]; end
+	subplot(3,1,1); plot([0.2:0.2:20],mean(surfmb)); title('Mean Surface mass balance');
+
+	%Plot velocity
+	vel=[]; for i=1:100; vel=[vel md.results.TransientSolution(i).Vel]; end
+	subplot(3,1,2); plot([0.2:0.2:20],mean(vel)); title('Mean Velocity');
+
+	%Plot Volume
+	volume=[]; for i=1:100; volume=[volume md.results.TransientSolution(i).IceVolume]; end
+	subplot(3,1,3); plot([0.2:0.2:20],volume); title('Ice Volume');
+	xlabel('years')
+end
Index: issm/trunk/examples/IceflowModels/Contour.exp
===================================================================
--- issm/trunk/examples/IceflowModels/Contour.exp	(revision 18301)
+++ issm/trunk/examples/IceflowModels/Contour.exp	(revision 18301)
@@ -0,0 +1,11 @@
+## Name:Contour
+## Icon:0
+# Points Count Value
+5 1.000000
+# X pos Y pos
+260815.7808871837 745919.4159004869
+712422.3484428506 757574.3645213632
+640499.8210173184 195805.8409951325
+342774.0098139530 279721.4710654409
+260815.7808871837 745919.4159004869
+
Index: issm/trunk/examples/IceflowModels/EISMINT.par
===================================================================
--- issm/trunk/examples/IceflowModels/EISMINT.par	(revision 18301)
+++ issm/trunk/examples/IceflowModels/EISMINT.par	(revision 18301)
@@ -0,0 +1,53 @@
+disp('      creating thickness');
+hmin=0.01;
+hmax=2756.7;
+radius=sqrt((md.mesh.x).^2+(md.mesh.y).^2);
+radiusmax=max(radius);
+radius(find(radius>(1.-10^-9)*radiusmax))=radiusmax;    %eliminate roundoff issues in next statement
+md.geometry.thickness=hmin*ones(size(md.mesh.x,1),1)+hmax*(4.*((1./2.)^(4./3.)*ones(size(md.mesh.x,1),1)-((radius)./(2.*radiusmax)).^(4./3.))).^(3./8.);
+md.geometry.base=0.*md.geometry.thickness;
+md.geometry.surface=md.geometry.base+md.geometry.thickness;
+
+disp('      creating drag');
+md.friction.coefficient=20.*ones(md.mesh.numberofvertices,1);
+md.friction.coefficient(find(md.mask.groundedice_levelset<0.))=0.;
+md.friction.p=ones(md.mesh.numberofelements,1);
+md.friction.q=ones(md.mesh.numberofelements,1);
+
+disp('      creating temperatures');
+tmin=238.15; %K
+st=1.67*10^-2/1000.; %k/m
+md.initialization.temperature=tmin+st*radius;
+md.basalforcings.geothermalflux=4.2*10^-2*ones(md.mesh.numberofvertices,1);
+
+disp('      creating flow law parameter');
+md.materials.rheology_B=6.81*10^7*ones(md.mesh.numberofvertices,1); %to have the same B as the analytical solution 
+md.materials.rheology_n=3.*ones(md.mesh.numberofelements,1);
+
+disp('      creating surface mass balance');
+smb_max=0.5; %m/yr
+sb=10^-2/1000.; %m/yr/m
+rel=450.*1000.; %m
+md.surfaceforcings.mass_balance=min(smb_max,sb*(rel-radius));
+
+disp('      creating velocities');
+constant=0.3;
+md.inversion.vx_obs=constant/2.*md.mesh.x.*(md.geometry.thickness).^-1;
+md.inversion.vy_obs=constant/2.*md.mesh.y.*(md.geometry.thickness).^-1;
+md.inversion.vel_obs=sqrt((md.inversion.vx_obs).^2+(md.inversion.vy_obs).^2);
+md.initialization.vx=zeros(md.mesh.numberofvertices,1);
+md.initialization.vy=zeros(md.mesh.numberofvertices,1);
+md.initialization.vz=zeros(md.mesh.numberofvertices,1);
+md.initialization.pressure=zeros(md.mesh.numberofvertices,1);
+
+%Deal with boundary conditions:
+disp('      boundary conditions for stressbalance model:');
+md=SetMarineIceSheetBC(md,'./RoundFront.exp');
+
+radius=sqrt((md.mesh.x).^2+(md.mesh.y).^2);
+pos=find(radius==min(radius));
+md.mesh.x(pos)=0.; md.mesh.y(pos)=0.; %the closest node to the center is changed to be exactly at the center
+
+md.stressbalance.spcvx(pos)=0.;
+md.stressbalance.spcvy(pos)=0.;
+md.stressbalance.spcvz(pos)=0.;
Index: issm/trunk/examples/IceflowModels/RoundFront.exp
===================================================================
--- issm/trunk/examples/IceflowModels/RoundFront.exp	(revision 18301)
+++ issm/trunk/examples/IceflowModels/RoundFront.exp	(revision 18301)
@@ -0,0 +1,47 @@
+## Name:
+## Icon:0
+# Points Count Value
+41 1
+# X pos Y pos
+1000000.000000 0.000000
+987688.340595 156434.465040
+951056.516295 309016.994375
+891006.524188 453990.499740
+809016.994375 587785.252292
+707106.781187 707106.781187
+587785.252292 809016.994375
+453990.499740 891006.524188
+309016.994375 951056.516295
+156434.465040 987688.340595
+0.000000 1000000.000000
+-156434.465040 987688.340595
+-309016.994375 951056.516295
+-453990.499740 891006.524188
+-587785.252292 809016.994375
+-707106.781187 707106.781187
+-809016.994375 587785.252292
+-891006.524188 453990.499740
+-951056.516295 309016.994375
+-987688.340595 156434.465040
+-1000000.000000 0.000000
+-987688.340595 -156434.465040
+-951056.516295 -309016.994375
+-891006.524188 -453990.499740
+-809016.994375 -587785.252292
+-707106.781187 -707106.781187
+-587785.252292 -809016.994375
+-453990.499740 -891006.524188
+-309016.994375 -951056.516295
+-156434.465040 -987688.340595
+-0.000000 -1000000.000000
+156434.465040 -987688.340595
+309016.994375 -951056.516295
+453990.499740 -891006.524188
+587785.252292 -809016.994375
+707106.781187 -707106.781187
+809016.994375 -587785.252292
+891006.524188 -453990.499740
+951056.516295 -309016.994375
+987688.340595 -156434.465040
+1000000.000000 0.000000
+
Index: issm/trunk/examples/IceflowModels/Square.exp
===================================================================
--- issm/trunk/examples/IceflowModels/Square.exp	(revision 18301)
+++ issm/trunk/examples/IceflowModels/Square.exp	(revision 18301)
@@ -0,0 +1,10 @@
+## Name:domainoutline
+## Icon:0
+# Points Count  Value
+5 1.
+# X pos Y pos
+0 0
+1000000 0
+1000000 1000000
+0 1000000
+0 0
Index: issm/trunk/examples/IceflowModels/SquareFront.exp
===================================================================
--- issm/trunk/examples/IceflowModels/SquareFront.exp	(revision 18301)
+++ issm/trunk/examples/IceflowModels/SquareFront.exp	(revision 18301)
@@ -0,0 +1,10 @@
+## Name:icefront
+## Icon:0
+# Points Count  Value
+5 1.
+# X pos Y pos
+-1000 900000
+-1000 1100000
+1100000 1100000
+1100000 900000
+-1000 900000
